import os
from constants.constants import TEST


class FileListParser:
    files = []
    exe_path = None
    vm_swap = None
    vm_rss = None

    def get_vm_info(self, pid):
        try:
            with open("/proc/%s/status" % pid, "r") as f:
                status_output = f.read().split("\n")
                for line in status_output:
                    if "VmSwap" in line:
                        self.vm_swap = int(line.split()[1]) * 1024
                    if "VmRSS" in line:
                        self.vm_rss = int(line.split()[1]) * 1024

        except:
            self.vm_swap = 0
            self.vm_rss = 0

    def list_files(self, pid):
        try:
            open_files_dir = os.scandir("/proc/%s/fd" % pid)
        except:
            open_files_dir = []
        for i in open_files_dir:
            try:
                file = os.readlink(i.path)
                if "/" in file:
                    self.files.append(file)
            except FileNotFoundError:
                pass
        try:
            self.exe_path = os.readlink("/proc/%s/exe" % pid)
        except FileNotFoundError:
            self.exe_path = ""

        self.get_vm_info(pid)

    def open_test_file(self):
        with open("../test_files/dc_lsfd", "r") as job_file:
            self.files = []
            self.exe_path = None
            self.vm_swap = None
            self.vm_rss = None
            job_file.readline()
            job = job_file.readline()
            while job:
                file = job.split(" -> ")[1].strip("\n")
                if "/" in file:
                    self.files.append(file)
                job = job_file.readline()
                self.exe_path = "/var/tmp"
                self.vm_swap = 50
                self.vm_rss = 300000

    def add_open_files_to_process(self, process):
        self.files = []
        self.exe_path = None
        self.vm_swap = None
        self.vm_rss = None
        if not TEST:
            self.list_files(process["pid"])
        else:
            self.open_test_file()
        process["open_files"] = self.files
        process["exe_path"] = self.exe_path
        process["vm_swap_bytes"] = self.vm_swap
        process["vm_rss_bytes"] = self.vm_rss
