import os
import subprocess


class JobsParser:
    command_output = []

    def load(self):
        list_jobs = subprocess.Popen("momctl -d3", shell=True, stdout=subprocess.PIPE, stderr=subprocess.DEVNULL).stdout
        self.command_output = list_jobs.read().decode().split("\n")
        list_jobs.close()
        return self

    def load_test_file(self):
        with open("../test_files/dc_jobslist", "r") as job_file:
            job = job_file.readline()
            while job:
                self.command_output.append(job)
                job = job_file.readline()
        return self

    def parse(self):
        jobs = []
        for line in self.command_output:
            if line.startswith("job"):
                tmp = line.split("  ")
                name = tmp[0]
                try:
                    sidlist = tmp[2].strip("\n").split("=")[1]
                except:
                    continue
                jobs.append((name, sidlist))
        return jobs
