import os
from datetime import datetime
from constants.constants import PS_USERNAME_CHAR_LIMIT


class ProcessParser:
    command_output = []
    user_processes = []

    def load(self):
        list_jobs = os.popen(
            "ps xao user:%s,pid,sid,uid,cputimes,lstart,command"
            % PS_USERNAME_CHAR_LIMIT
        )
        lines = list_jobs.read().split("\n")
        self.command_output = [line.split(maxsplit=10) for line in lines]
        self.command_output.pop(0)
        self.command_output.pop()
        list_jobs.close()
        return self

    def load_test_file(self):
        with open("../test_files/dc_psout", "r") as job_file:
            job = job_file.readline()
            while job:
                job = job_file.readline()
                self.command_output.append(job.split(maxsplit=10))
        return self

    def isolate_important_processes(self):
        processes = []
        for proc in self.command_output:
            if proc:
                if int(proc[3]) >= 1000:
                    processes.append(proc)
        self.user_processes = processes

    def parse(self, jobs):
        self.isolate_important_processes()
        processes = {}
        for proc in self.user_processes:
            stime = datetime.strptime(" ".join(proc[6:10]), "%b %d %H:%M:%S %Y")
            stime_timestamp = int(stime.timestamp())
            current_time = datetime.now().timestamp()
            proc_dict = {
                "user": proc[0],
                "pid": proc[1],
                "sid": proc[2],
                "uid": proc[3],
                "stime": stime_timestamp,
                "cputime": proc[4],
                "time": int(current_time - stime_timestamp),
                "command": proc[10].strip("\n"),
            }
            processes["%s_%s_%s" % (proc[0], proc[1], stime_timestamp)] = proc_dict
        for line in self.user_processes:
            stime = datetime.strptime(" ".join(line[6:10]), "%b %d %H:%M:%S %Y")
            stime_timestamp = int(stime.timestamp())
            for job in jobs:
                if job[1] == line[2]:
                    job_stripped = [job[0].lstrip("job[").rstrip("]"), job[1]]
                    proc_name = "%s_%s_%s" % (line[0], line[1], stime_timestamp)
                    processes[proc_name]["job"] = job_stripped
        return processes
