from collector_parsers.Process import Process


class Job:
    def __init__(self, job_tuple):
        self.__pid = job_tuple[0]
        self.__user = job_tuple[1][0][0]
        self.__running = False
        self.__end_time = None
        self.__processes = [Process(process) for process in job_tuple[1]]
        self.__time = 0

    def to_dict(self):
        output = {
            "pid": self.__pid,
            "user": self.__user,
            "time": self.__time,
            "running": self.__running,
            "end_time": self.__end_time,
            "processes": [process.to_dict() for process in self.__processes],
        }
        return output
